<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/tv/default_channel.php';

///////////////////////////////////////////////////////////////////////////

class ExtChannel extends DefaultChannel
{
    
    private $number;
    private $past_epg_days;
    private $future_epg_days;
    private $is_protected;

    ///////////////////////////////////////////////////////////////////////

    public function __construct(
        $id, $title, $icon_url, $has_archive, $number, $past_epg_days, $future_epg_days, $is_protected)
    {
        parent::__construct($id, $title, $icon_url, $streaming_url);
        
        $this->has_archive = $has_archive;
        $this->number = $number;
        $this->past_epg_days = $past_epg_days;
        $this->future_epg_days = $future_epg_days;
        $this->is_protected = $is_protected;
    }

    ///////////////////////////////////////////////////////////////////////
    public function has_archive()
    {
	return $this->has_archive;
    }
    
    public function get_number()
    { return $this->number; }

    public function get_past_epg_days()
    { return $this->past_epg_days; }

    public function get_future_epg_days()
    { return $this->future_epg_days; }
    
    ///////////////////////////////Получение ссылки на ресурс////////////
    
    public function setCook ($plg_cook)
    {
        $this->cook = $plg_cook;
    }
    
    /////////////////////////////////
    public function is_protected()
    {
        $plugin_cookies = $this->cook;
        
	if ($plugin_cookies->ask_pc == 'no')
	{
	    return false;
	} 
	else
	{
	    return $this->is_protected;
	}
    }
    public function real_is_protected()
    {
	return $this->is_protected;
    }
    /////////////////////////////////
    
    public function get_streaming_url()
    {
        $plugin_cookies = $this->cook;
        
        $query = '&query=get_url&key=number&value='.$this->get_id();
        $xml = ExtTv::load_xml($plugin_cookies, $query, 'Невозможно получить поток!'); 
                
        $url = $xml->row[0]->xpath("item[@name='url']");
        
        $this->_streaming_url = strval($url[0]);
        
        return $this->_streaming_url;
        
    }
    
    ////////////////////////////////////////////////////////////////////
    
}

///////////////////////////////////////////////////////////////////////////
?>
