<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/default_dune_plugin.php';
require_once 'lib/utils.php';

require_once 'lib/tv/tv_group_list_screen.php';
require_once 'lib/tv/tv_favorites_screen.php';

require_once 'lib/vod/vod_list_screen.php';
require_once 'lib/vod/vod_movie_screen.php';
require_once 'lib/vod/vod_series_list_screen.php';
require_once 'lib/vod/vod_favorites_screen.php';

require_once 'ext_config.php';

require_once 'ext_tv.php';
require_once 'ext_m3u_tv.php';
require_once 'ext_vod.php';
require_once 'ext_setup_screen.php';
require_once 'ext_auth_screen.php';
require_once 'ext_tv_channel_list_screen.php';
require_once 'ext_vod_category_list_screen.php';
require_once 'ext_vod_list_screen.php';

require_once 'ext_session.php';

///////////////////////////////////////////////////////////////////////////

class ExtPlugin extends DefaultDunePlugin
{
    private $session;
    
    public function __construct()
    {
        $this->session = new ExtSession();
        
        $this->tv =
            ExtConfig::USE_M3U_FILE ?
            new ExtM3uTv() :
            new ExtTv($this->session);

        $this->vod = new ExtVod();

        if (!ExtConfig::USE_M3U_FILE)
        {
            $this->add_screen(new TvGroupListScreen($this->tv,
                    ExtConfig::GET_TV_GROUP_LIST_FOLDER_VIEWS()));
        }

        $this->add_screen(new ExtTvChannelListScreen($this->tv,
                ExtConfig::GET_TV_CHANNEL_LIST_FOLDER_VIEWS()));
        $this->add_screen(new TvFavoritesScreen($this->tv,
                ExtConfig::GET_TV_CHANNEL_LIST_FOLDER_VIEWS()));

        $this->add_screen(new ExtSetupScreen());
        $this->add_screen(new ExtAuthScreen());
        
        $this->add_screen(new VodFavoritesScreen($this->vod));
        $this->add_screen(new ExtVodCategoryListScreen());
        $this->add_screen(new ExtVodListScreen($this->vod));
        $this->add_screen(new VodMovieScreen($this->vod));
        $this->add_screen(new VodSeriesListScreen($this->vod));
    }
}

///////////////////////////////////////////////////////////////////////////
?>
