<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/hashed_array.php';
require_once 'lib/tv/abstract_tv.php';
require_once 'lib/tv/default_epg_item.php';


require_once 'ext_channel.php';

///////////////////////////////////////////////////////////////////////////

class ExtTv extends AbstractTv
{
    protected $path = array( 
		'100' => 'plugin_file://icons/national.jpg',
		'102' => 'plugin_file://icons/cinema.jpg',
		'105' => 'plugin_file://icons/educational.jpg',
		'101' => 'plugin_file://icons/family.jpg',
		'107' => 'plugin_file://icons/info.jpg',
		'106' => 'plugin_file://icons/kids.jpg',
		'108' => 'plugin_file://icons/music.jpg',
		'104' => 'plugin_file://icons/sport.jpg' );
    
    private $session;

    public function __construct($session)
    {
        $this->session = $session;
        
        parent::__construct(
            AbstractTv::MODE_CHANNELS_N_TO_M,
            ExtConfig::TV_FAVORITES_SUPPORTED,
            false);
    }

    public function get_fav_icon_url()
    {
        return ExtConfig::FAV_CHANNEL_GROUP_ICON_PATH;
    }

    ///////////////////////////////////////////////////////////////////////
    
     /////////////////////////////////Загрузка XML//////////////////////////////////////////

    public static function authorization(&$plugin_cookies)
    {
	$login= $plugin_cookies->login;
	$pass= $plugin_cookies->pass;
        
	//=====================этап 1====================//
	$doc = HD::http_get_document(ExtConfig::CHANNEL_LIST_URL);
        
	$xml = simplexml_load_string($doc);
        
	if ($xml === false)
        {
            hd_print("Error: can not parse XML document.");
            hd_print("XML-text: $doc.");
            throw new Exception('Illegal XML document');
        }
        
        if ($xml->getName() !== 'entity')
        {
            hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'tv_info'");
            throw new Exception('Invalid XML document');
        }
	$rand = $xml->row->xpath("item[@name='rand']");
	$sid = $xml->row->xpath("item[@name='sid']");
	$send_pass=md5($rand[0].md5($pass));
        
	//=====================этап 2====================//
	$doc = HD::http_get_document(sprintf(ExtConfig::EPG_URL_FORMAT,'dune_hd','1.0.0',$sid[0],$login,$send_pass,HD::get_mac_addr()));
	
        $xml = simplexml_load_string($doc);
        
	if ($xml === false)
        {
            hd_print("Error: can not parse XML document.");
            hd_print("XML-text: $doc.");
            throw new Exception('Illegal XML document');
        }
        
        if ($xml->getName() !== 'entity')
        {
            hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'tv_info'");
            throw new Exception('Invalid XML document');
        }
	
	if (strcmp($xml['status'], 'success') != 0)
	    throw new DuneException(
                'Authorization error', 1,
                ActionFactory::show_error(
                    true,
                    'Ошибка доступа',
                    array(
                        'Не удаётся подключиться к IPTV-серверу.',
                        'Проверьте введенные логин и пароль.')));
	    
	$portal = $xml->row->xpath("item[@name='portal']");
	$token = $xml->row->xpath("item[@name='token']");
	//$ttl = $xml->row->xpath("item[@name='ttl']");
        
	$plugin_cookies->portal= strval($portal[0]);
	$plugin_cookies->token= strval($token[0]);
        //$plugin_cookies->ttl= strval($ttl[0]);

    }

    ///////////////////////////////////////////////////////////////////////////
    
    public static function load_xml(&$plugin_cookies, $query_end, $error_message)
    {
        
        $query = $plugin_cookies->portal.'?token='.$plugin_cookies->token.$query_end;
        
        try
        {
            $doc = HD::http_get_document($query);
        }
        catch(Exception $e)
        {
            throw new DuneException(
		    'HTTP network error', 0,
		    ActionFactory::show_error(
			true,
			'Ошибка связи',
			 array(
			    'Не удаётся подключиться к IPTV-серверу.',
			    'Проверьте подключение к сети Интернет.')));
        }
        
        hd_print("XML is: ".$doc);
        
	$xml = simplexml_load_string($doc);
        
	if ($xml === false)
	{
	    hd_print("Error: can not parse XML document.");
	    hd_print("XML-text: $doc.");
	    throw new Exception('Illegal XML document');
	}
        
        if ($xml['status'] == 'error')
	{
            $code = $xml->row[0]->xpath("item[@name='code']");
            hd_print("777777777777: ".$code[0]);
            
            if (strval($code[0]) == '4001')
            {
		throw new DuneException(
			'Load XML error', 5,
			ActionFactory::show_error(
			    true,
			    'Ошибка получения данных',
			    array($error_message)));
            } 
	    elseif (strval($code[0]) == '4002')
	    {
		
		ExtTv::authorization($plugin_cookies);
		
                $query = $plugin_cookies->portal.'?token='.$plugin_cookies->token.$query_end;

		try
		{
		    $doc = HD::http_get_document($query);
		}
		catch (Exception $e)
		{
		    throw new DuneException(
			'HTTP network error', 0,
			ActionFactory::show_error(
			    true,
			    'Ошибка связи',
			    array(
			        'Не удаётся подключиться к IPTV-серверу.',
			        'Проверьте подключение к сети Интернет.')));
		}
		
		$xml = simplexml_load_string($doc);

		if ($xml === false)
		{
		    hd_print("Error: can not parse XML document.");
		    hd_print("XML-text: $doc.");
		    throw new Exception('Illegal XML document');
		}
	    }
	    elseif (strval($code[0]) == '4006')
            {
            ////////////////////////////////////////////////////////////////
                ExtTv::authorization($plugin_cookies);
		
                $query = $plugin_cookies->portal.'?token='.$plugin_cookies->token.$query_end;
                
		$doc = HD::http_get_document($query);
                
                throw new DuneException(
			'Other user error', 7,
			ActionFactory::show_error(
			    true,
			    'Ваша учетная запись уже используется!',
			    array('Кто-то другой использует эту учетную запись...')));
            }
	    else
            {
		throw new DuneException(
			'Load XML error', 5,
			ActionFactory::show_error(
			    true,
			    'Ошибка получения данных',
			    array($error_message)));
            }
        }
    ///////////////////////////////////////////////////////////////////////////// 
        
	return $xml;
    }
    
    ///////////////////////////////////////////////////////////////////////
    ////////////////////////////Загрузка каналов//////////////////////////
    
    protected function load_channels(&$plugin_cookies)
    {
        $query = '&query=get_channels';
        
        $xml = $this->load_xml($plugin_cookies, $query, 'Невозможно получить список каналов!');
        
        if ($xml->getName() !== 'entity')
        {
            hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'tv_info'");
            throw new Exception('Invalid XML document');
        }
        
        $this->channels = new HashedArray();
        $this->groups = new HashedArray();
        
        if ($this->is_favorites_supported())
        {
            $this->groups->put(
                new FavoritesGroup(
                    $this,
                    '__favorites',
                    ExtConfig::FAV_CHANNEL_GROUP_CAPTION,
                    ExtConfig::FAV_CHANNEL_GROUP_ICON_PATH));
        }
        
        $this->groups->put(
            new AllChannelsGroup(
                $this,
                ExtConfig::ALL_CHANNEL_GROUP_CAPTION,
                ExtConfig::ALL_CHANNEL_GROUP_ICON_PATH));
        
        $ch_arr=$xml->row[0]->xpath("array[@name='channels']");
        
        foreach ($ch_arr[0] as $xml_tv_channel)
        {
            if ($xml_tv_channel->getName() !== 'row')
            {
                hd_print("Error: unexpected node '" . $xml_tv_channel->getName() .
                    "'. Expected: 'tv_channel'");
                throw new Exception('Invalid XML document');
            }
            
	    $number = $xml_tv_channel->xpath("item[@name='number']");
	    $title = $xml_tv_channel->xpath("item[@name='title']");
	    $icon = $xml_tv_channel->xpath("item[@name='icon_100_100']");
	    $has_archive = $xml_tv_channel->xpath("item[@name='has_record']");
	    $is_protected = $xml_tv_channel->xpath("item[@name='has_passwd']");
            
	    if ( intval($is_protected[0]) == 0 )
		$flag = false;
	    else
		$flag = true;
                
	    if ($flag == false || $plugin_cookies->show_pc != 'no')
	    {
		    $channel =
		        new ExtChannel(
		            strval($number[0]),
		            strval($title[0]),
		            strval($icon[0]),
                            intval($has_archive[0]),
		            intval($number[0]),
			    intval(6),
			    intval(6),
                            $flag);
                        
                    $channel->setCook($plugin_cookies);
                    
            $this->channels->put($channel);
	    }
            
        }
        
        $categ_arr=$xml->row[0]->xpath("array[@name='categories']");
        
        foreach ($categ_arr[0] as $xml_tv_category)
        {
            if ($xml_tv_category->getName() !== 'row')
            {
                hd_print("Error: unexpected node '" . $xml_tv_category->getName() .
                    "'. Expected: 'tv_category'");
                throw new Exception('Invalid XML document');
            }
	    $number = $xml_tv_category->xpath("item[@name='number']");
	    $title = $xml_tv_category->xpath("item[@name='title']");
	 
	    $group = new DefaultGroup(
                    strval($number[0]),
                    strval($title[0]),
                    strval($this->path[strval($number[0])])); /// иконки категорий ////'100' => 'plugin_file://icons/national.jpg',
            $this->groups->put($group);
            
	    $ch_arr = $xml_tv_category->xpath("array[@name='channels']");
	    foreach($ch_arr[0] as $ch_num)
	    {
		$channel = $this->channels->get(intval($ch_num));
		if ($channel)
		{
		    // Link group and channel.
		    $channel->add_group($group);
                    $group->add_channel($channel);
		}
	    }
        }

    }
    
    ////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////Загрузка телегида//////////////////////////////////
    
    public function get_day_epg_iterator($channel_id, $day_start_ts, &$plugin_cookies)
    {
        $query = '&query=get_epg&key=number|start|period&value='.$channel_id.'|'.$day_start_ts.'|86400';
	try{
            $xml = $this->load_xml($plugin_cookies, $query, 'Невозможно получить телегид!');
	}
	catch(Exception $e)
	{
	    hd_print('Ошибка: '.$e->getMessage());
	    return array();
	}
        
        if ($xml->getName() !== 'entity')
        {
            hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'NewDataSet'");
            throw new Exception('Invalid XML document');
        }
	
	$epg = array();
	$message=$xml->row[0]->xpath("item[@name='message']");
	if (strcmp($xml['status'], 'success') != 0)
	    if (strcmp($xml['status'], 'error') == 0 && strcmp($message[0], 'No data') == 0)
		return
		    new EpgIterator(
                    $epg,
                    $day_start_ts,
                    $day_start_ts + 86400);
	   else
	    throw new DuneException(
                'HTTP network error', 2,
                ActionFactory::show_error(
                    true,
                    'Ошибка доступа!',
                    array(
                        'Ошибка доступа!')));
        
        
	$ch_num = $xml->row[0]->xpath("item[@name='number']");
	if (intval($ch_num[0]) != intval($channel_id))
	     throw new DuneException(
                'HTTP network error', 3,
                ActionFactory::show_error(
                    true,
                    'Ошибка номера канала!',
                    array('Ошибка номера канала!')));
            
	$pr_arr = $xml->row[0]->xpath("array[@name='programmes']");
        
        foreach ($pr_arr[0] as $epg_item)
        {
            if ($epg_item->getName() !== 'row')
            {
                hd_print("Error: unexpected node '" . $epg_item->getName() .
                    "'. Expected: 'epg_item'");
                throw new Exception('Invalid XML document');
            }
	    
	    $title = $epg_item->xpath("item[@name='title']");
	    $start = $epg_item->xpath("item[@name='ut_start']");
	    $stop = $epg_item->xpath("item[@name='ut_stop']");
	    $desc = $epg_item->xpath("item[@name='desc']");
	   
            $epg[] =
                new DefaultEpgItem(
                    strval($title[0]),
                    strval($desc[0]),
                    intval($start[0]),
                    intval($stop[0]));
        }
        
        return
            new EpgIterator(
                $epg,
                $day_start_ts,
                $day_start_ts + 86400);
    }
    
    public function get_tv_stream_url($playback_url, &$plugin_cookies)
    {
        hd_print('start get_tv_stream_url()======>>>>'.$playback_url);
        return $this->session->api_get_stream_url($playback_url, $plugin_cookies, $this->channel_id);

    }
    public function get_tv_playback_url($channel_id, $archive_ts, $protect_code, &$plugin_cookies)
    {
        hd_print('start get_tv_playback_url()---->');
        $this->ensure_channels_loaded($plugin_cookies);
        
        $this->channel_id = $channel_id;

        return $this->get_channel($channel_id)->get_streaming_url();
    
    }

}

///////////////////////////////////////////////////////////////////////////


?>
